const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const cart_items = sequelize.define(
    'cart_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

item_name: {
        type: DataTypes.TEXT,
      
      

      },

unit_price: {
        type: DataTypes.DECIMAL,
      
      

      },

quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

line_discount_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

line_tax_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

line_total_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  cart_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

































//end loop



    db.cart_items.belongsTo(db.carts, {
      as: 'cart',
      foreignKey: {
        name: 'cartId',
      },
      constraints: false,
    });

    db.cart_items.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.cart_items.belongsTo(db.product_variants, {
      as: 'product_variant',
      foreignKey: {
        name: 'product_variantId',
      },
      constraints: false,
    });

    db.cart_items.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.cart_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.cart_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return cart_items;
};


